# coding=utf-8
#####################################################
# THIS FILE IS AUTOMATICALLY GENERATED. DO NOT EDIT #
#####################################################
# noqa: E128,E201
from .asyncclient import AsyncBaseClient
from .asyncclient import createApiClient
from .asyncclient import config
from .asyncclient import createTemporaryCredentials
from .asyncclient import createSession
_defaultConfig = config


class Login(AsyncBaseClient):
    """
    The Login service serves as the interface between external authentication
    systems and TaskCluster credentials.  It acts as the server side of
    https://tools.taskcluster.net.  If you are working on federating logins
    with TaskCluster, this is probably *not* the service you are looking for.
    Instead, use the federated login support in the tools site.
    """

    classOptions = {
        "baseUrl": "https://login.taskcluster.net/v1"
    }

    async def credentialsFromPersonaAssertion(self, *args, **kwargs):
        """
        Get TaskCluster credentials given a Persona assertion

        Given an [assertion](https://developer.mozilla.org/en-US/Persona/Quick_setup), return an appropriate set of temporary credentials.

        The supplied audience must be on a whitelist of TaskCluster-related
        sites configured in the login service.  This is not a general-purpose
        assertion-verification service!

        This method takes input: ``http://schemas.taskcluster.net/login/v1/persona-request.json``

        This method takes output: ``http://schemas.taskcluster.net/login/v1/credentials-response.json``

        This method is ``experimental``
        """

        return await self._makeApiCall(self.funcinfo["credentialsFromPersonaAssertion"], *args, **kwargs)

    async def ping(self, *args, **kwargs):
        """
        Ping Server

        Respond without doing anything.
        This endpoint is used to check that the service is up.

        This method is ``stable``
        """

        return await self._makeApiCall(self.funcinfo["ping"], *args, **kwargs)

    funcinfo = {
        "credentialsFromPersonaAssertion": {           'args': [],
            'input': 'http://schemas.taskcluster.net/login/v1/persona-request.json',
            'method': 'post',
            'name': 'credentialsFromPersonaAssertion',
            'output': 'http://schemas.taskcluster.net/login/v1/credentials-response.json',
            'route': '/persona',
            'stability': 'experimental'},
        "ping": {           'args': [],
            'method': 'get',
            'name': 'ping',
            'route': '/ping',
            'stability': 'stable'},
    }


__all__ = ['createTemporaryCredentials', 'config', '_defaultConfig', 'createApiClient', 'createSession', 'Login']
